#ifndef HANDLE_NOTIFICATIONS_CLASS_H
#define HANDLE_NOTIFICATIONS_CLASS_H

#include <omnetpp.h>
#include <map>
#include "Ieee80211MgmtAPBase.h"
#include "NotificationBoard.h"
#include "APNotification_m.h"
#include "Ieee802Ctrl_m.h"
#include "EtherFrame_m.h"
#include "Ieee80211Frame_m.h"
#include "NotifierConsts.h"
#include "RadioState.h"
#include "buffer.h"


#define	ASS_NOTIF			0x10
#define	DISASS_NOTIF		0x11
#define	DEST_FOUND_NOTIF	0x12
#define REMOVE_FRAMES_NOTIF	0x13
#define UPDATE_FRAMES_NOTIF 0x14
#define STORE_FRAMES		0x15
#define FETCH_FRAMES		0x16

#define SUCCESS				1
#define FAILURE				-1

#define DEST_INFO_ENTRY_MODIFIED	0x20
#define DEST_INFO_ENTRY_ADDED		0x21
#define DEST_INFO_ENTRY_REMOVED		0x22
#define DEST_INFO_ENTRY_FOUND		0x23
#define DEST_INFO_ENTRY_NOT_FOUND	0x24

#define DEST_BUFFER_AP_ADDED				0x30
#define	DEST_BUFFER_ENTRY_MODIFIED			0x31
#define DEST_BUFFER_INFO_ENTRY_FOUND		0x32
#define DEST_BUFFER_INFO_ENTRY_NOT_FOUND	0x33

#pragma once

struct DestBufferInfo
{
	MACAddress destNodeAddress;
	MACAddress respAPAddress;
};

struct DestInfo
{
	MACAddress destNodeAddress;
	MACAddress assAPAddress;
};

class HandleNotificationsClass : public cSimpleModule
{
public:
	HandleNotificationsClass(void);
	int HandleNotificationsClass::CheckNotificationMsg(cMessage *msg, MACAddress* destAddress, MACAddress* apAddress, int *numFrames, Ieee80211DataFrame *frameNotif, MACAddress myAddress);
	EtherFrame* SendNotificationToAPs(int notifType, MACAddress nodeAddress, MACAddress apAddress, int numFrames, Ieee80211DataFrame* frame);
	int CheckForDestInfo(MACAddress frameAddres, MACAddress* apAddress);
	int AddOrModifyDestInfo(MACAddress srcMACAddress, MACAddress assAPMACAddress);
	int RemoveDestInfo(MACAddress srcMACAddress);
	int CheckAndAddDestBufferAP(MACAddress srcMACAddress, MACAddress assAPMACAddress);
	int HandleNotificationsClass::CheckForDestBufferInfo(MACAddress frameAddress, MACAddress* apAddress);

	std::list<struct DestInfo> destInfoList;
	std::list<struct DestBufferInfo> destBufferInfoList;

public:
	~HandleNotificationsClass(void);
};

#endif
