#ifndef BUFFER_H_
#define BUFFER_H_


#include <stdlib.h>
#include <list>
#include "Ieee802Ctrl_m.h"
#include "EtherFrame_m.h"
#include "NotifierConsts.h"
#include "RadioState.h"
#include "Ieee80211MgmtAPBase.h"
#include "NotificationBoard.h"
#include "Ieee80211Frame_m.h"


#define  LP_PKT_DROP  00
#define  HP_PKT_DROP  01
#define  TTL_EXP_DROP 10

struct dropPacketsInfo_t
{
	MACAddress	nodeAddress_;
	int			lowPriorityLossCounter_;
	int			highPriorityLossCounter_;
	int			ttlExpiredCounter_;
};

typedef struct
{
	Ieee80211DataFrame frame;
	int ttl;
	int priority;

}bufferedFrames_t;

class BufferClass
{
 public: 
    BufferClass();	// Constructor
    
//	std::list<Ieee80211DataFrame> ptrPktList_;
	std::list<bufferedFrames_t> ptrPktList_;
    int listSize_;
//    list<struct dropPacketsInfo_t*> ptrDropPacketsInfo_;
//    struct dropPacketsInfo_t dropPacketsInfo_[10];
//    int sizeDPI_;

    
    inline int GetSizeList() {return listSize_;}
    inline void SetBufferLimitList(int limit) {listBufferLimit_ = limit;}
    
    void AddElementToList(bufferedFrames_t frameToAdd);
	void RemoveElementFromList(std::list<Ieee80211DataFrame*>::iterator newIterator);
    int IsPacketTagged(bufferedFrames_t frameToAdd);
    void DecrementTTLValueOfElements(void);
//    void CheckAndAddEntryInDropList(nsaddr_t destAddress, int type);
    int lowPriorityLossCounter_;
    int highPriorityLossCounter_;
    int ttlExpiredCounter_;
    
	int listBufferLimit_;   
};


#endif
