//
// Copyright (c) 2007 INRIA
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Authors:   Ahmed Ayadi < Ahmed.Ayadi@sophia.inria.fr>
//           Masood Khosroshahy < m.khosroshahy@iee.org>
//
#ifndef FREESPACEMODEL_H
#define FREESPACEMODEL_H

#include "IReceptionModel.h"

/**
 * Free Space Path loss model which calculates the received power.
 */
class INET_API FreeSpaceModel : public IReceptionModel
{
  private:
    double systemLoss;
    double receiverAntennaGain;

  public:
    /**
     * Parameters read from the radio module: pathLossAlpha.
     */
    virtual void initializeFrom(cModule *radioModule);

    /**
     * Perform the calculation.
     */
    virtual double calculateReceivedPower(double pSend, double carrierFrequency, double distance);
};

#endif

