/***************************************************************************
                          RTPAVProfilePayload10Sender.h  -  description
                             -------------------
    begin                : Mon Sep 24 2007
    copyright            : (C) 2007 by Ahmed Ayadi, Matthias Oppitz
    email                : Matthias.Oppitz@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** \file RTPAVProfilePayload10Sender.h
 * This file declares the class RTPAVProfilePayload10Sender.
 */

 
#ifndef __RTPAVPROFILEPAYLOAD10SENDER_H__
#define __RTPAVPROFILEPAYLOAD10SENDER_H__

#include <omnetpp.h>
#include "RTPPayloadSender.h"

/**
 * An RTPAVProfilePayload10Sender is a module for sending data of payload
 * type 32 
 * The corresponding receiver module RTPAVProfilePayload10Receiver.
 */
class INET_API RTPAVProfilePayload10Sender : public RTPPayloadSender
{

  protected:

    /**
     * Initializes the module. It sets the values for clock rate and payload type.
     */
    virtual void initialize();

    /**
     * The main method.
     */
    //virtual void activity();

    protected:

        /**
         * This method reads the gdf file header.
         */
        virtual void initializeSenderModule(RTPInnerPacket *rinpIn);

        /**
         * This method sends one mpeg frame. It sends one or more
         * rtp data packet. Returns false if there were no more frames.
         */
        virtual bool sendPacket();

        /**
         * The initial delay of the mpeg video.
         */
        double _initialDelay;

        /**
         * The number of frames per second of the mpeg video.
         */
        double _framesPerSecond;

        /**
         * The number of the current mpeg frame. Needed for calculating
         * the rtp time stamp in the rtp data packets.
         */
        double _frameNumber;

};

#endif
